<?php
/**
 * @package Aviasales
 */
/*
Plugin Name: Aviasales
Plugin URI: http://www.aviasales.ru/
Description: Поисковый виджет для поиска билетов Aviasales.ru через ваш блог. Зарабатывайте на вашем блоге с помощью авиабилетов.
Version: 1.0.2
Author: aviasales.ru
Author URI: http://www.aviasales.ru
License: GPLv2 or later
*/

// if called directly
if ( !function_exists( 'add_action' ) ) {
	echo "Shoooosh!!1";
	exit;
}

class Aviasales extends WP_Widget {
	
	public function Aviasales() {
		
		parent::__construct( 'aviasales', 'Aviasales', array(
			'classname'			=> 'aviasales', 
			'description'		=> 'Displays Aviasales search form'
		), array(
			'id_base'			=> 'aviasales'
		) );
		
	}
	
	public function form( $instance ) {
		
		if ( !is_readable( plugin_dir_path( __FILE__ ) . 'params.php' ) )
			return ;
		
		wp_enqueue_script( 'jquery' );
		wp_enqueue_script( 'jquery-effects-slide' );
		wp_enqueue_script( 'aviasales-admin-script', plugins_url( 'js/aviasales_admin.js', __FILE__ ) );
		wp_enqueue_style( 'aviasales-admin-style', plugins_url( 'css/aviasales_admin.css', __FILE__ ) );
		
		$validate = $this->form_validate( $instance );
		
		include plugin_dir_path( __FILE__ ) . 'params.php';
		
	}
	
		private function form_validate( $instance ) {
			
			return array(
				'affiliate_id'				=> ( isset( $instance['affiliate_id'] ) && (int)$instance['affiliate_id'] ? TRUE : FALSE ),
				'widget_title'				=> TRUE,
				'background_color'			=> ( ( !isset( $instance['background_color'] )	|| !trim( $instance['background_color'] ) )	|| preg_match( '/^\#([0-9a-f]{3}|[0-9a-f]{6})$/i', trim( $instance['background_color'] ) )							? TRUE : FALSE ),
				'border_color'				=> ( ( !isset( $instance['border_color'] )		|| !trim( $instance['border_color'] ) )		|| preg_match( '/^\#([0-9a-f]{3}|[0-9a-f]{6})$/i', trim( $instance['border_color'] ) )								? TRUE : FALSE ),
				'header_color'				=> ( ( !isset( $instance['header_color'] )		|| !trim( $instance['header_color'] ) )		|| preg_match( '/^\#([0-9a-f]{3}|[0-9a-f]{6})$/i', trim( $instance['header_color'] ) )								? TRUE : FALSE ),
				'text_color'				=> ( ( !isset( $instance['text_color'] )		|| !trim( $instance['text_color'] ) )		|| preg_match( '/^\#([0-9a-f]{3}|[0-9a-f]{6})$/i', trim( $instance['text_color'] ) )								? TRUE : FALSE ),
				'white_label'				=> ( ( !isset( $instance['white_label'] )		|| !trim( $instance['white_label'] ) )		|| preg_match( '/^[\.\_\-\d\p{L}]+$/iu', trim( $instance['white_label'] ) )												? TRUE : FALSE ),
				'show_hotels'				=> TRUE,
				'currency'					=> TRUE
			); 
			
		}

	public function update( $new_instance, $old_instance ) {
		return $new_instance;
	}

	public function widget( $args, $instance ) {
		
		include 'widget.php';
		
	}
	
	public static function script_list() {
		
		if ( is_admin() )
			return ;
		
		wp_enqueue_script( 'jquery' );
		
		//wp_enqueue_script( 'jquery-ui-core' );
		//wp_enqueue_script( 'jquery-ui-datepicker' );
		
		wp_enqueue_script( 'aviasales-jquery-ui', 'http://yandex.st/jquery-ui/1.8.16/jquery-ui.min.js' );
		wp_enqueue_script( 'aviasales-jquery-i18n', 'http://yandex.st/jquery-ui/1.8.15/i18n/jquery.ui.datepicker-ru.min.js' );
		
		wp_enqueue_script( 'pure', plugins_url( 'js/pure.min.js', __FILE__ ) );
		wp_enqueue_script( 'underscore', plugins_url( 'js/underscore-min.js', __FILE__ ) );
		
		wp_enqueue_script( 'aviasales-autocomplete', 'http://nano.aviasales.ru/assets/autocomplete_places_ru.js' );
		wp_enqueue_script( 'aviasales-inline-form', 'http://nano.aviasales.ru/assets/minimal/inline_form.js' );
		
		wp_enqueue_script( 'aviasales-init', plugins_url( 'js/aviasales.js', __FILE__ ) );
		
	}
	
	public static function style_list() {
		
		if ( is_admin() )
			return ;
		
		wp_enqueue_style( 'aviasales-ui', 'http://yandex.st/jquery-ui/1.8.15/themes/humanity/jquery.ui.all.min.css' );
		wp_enqueue_style( 'aviasales-common', plugins_url( 'css/aviasales.css', __FILE__ ) );
		
	}
	
}

add_action( 'widgets_init', create_function( '', 'return register_widget( "Aviasales" );' ) );
add_action( 'wp_print_scripts', array( 'Aviasales', 'script_list' ) );
add_action( 'wp_print_styles', array( 'Aviasales', 'style_list' ) );
